// TestThreadDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestThread.h"
#include "TestThreadDlg.h"
#include <process.h>
#include "TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestThreadDlg dialog

CTestThreadDlg::CTestThreadDlg(CWnd* pParent /*=NULL*/)
: CDialog(CTestThreadDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestThreadDlg)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestThreadDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestThreadDlg)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestThreadDlg, CDialog)
//{{AFX_MSG_MAP(CTestThreadDlg)
ON_WM_SYSCOMMAND()
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_BN_CLICKED(IDC_START_THREAD, OnStartThread)
ON_BN_CLICKED(IDC_BEGIN_THREAD, OnBeginThread)
ON_BN_CLICKED(IDC_WAIT_TERM, OnWaitTerm)
	ON_BN_CLICKED(IDC_AFXBEGINTHREAD_FUNCTION, OnAfxbeginthreadFunction)
	ON_BN_CLICKED(IDC_CREATE_MYWINTHREAD, OnCreateMywinthread)
	ON_BN_CLICKED(IDC_TM_BLOCKING_CALL, OnTmBlockingCall)
	ON_BN_CLICKED(IDC_BLOCKING_CALL, OnBlockingCall)
	ON_BN_CLICKED(IDC_CREATE_WORKER, OnCreateWorker)
	ON_BN_CLICKED(IDC_POST_WORKER, OnPostWorker)
	ON_BN_CLICKED(IDC_WIN32_THREAD, OnWin32Thread)
	ON_BN_CLICKED(IDC_MFC_THREAD, OnMfcThread)
	ON_BN_CLICKED(IDC_EVENT, OnEvent)
	ON_BN_CLICKED(IDC_SETEVENT, OnSetevent)
	ON_BN_CLICKED(IDC_EVENTS, OnEvents)
	ON_BN_CLICKED(IDC_SETEVENT1, OnSetevent1)
	ON_BN_CLICKED(IDC_SETEVENT2, OnSetevent2)
	ON_BN_CLICKED(IDC_CRITICAL_SECTION, OnCriticalSection)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestThreadDlg message handlers

BOOL CTestThreadDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Add "About..." menu item to system menu.
	
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestThreadDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestThreadDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestThreadDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


DWORD WINAPI ThreadFunc( LPVOID lpParam ) 
{ 
	::MessageBox( NULL, "ThreadFunc", "Thread", MB_OK );
    return 0; 
} 

void CTestThreadDlg::OnStartThread() 
{
	// TODO: Add your control notification handler code here
    DWORD dwThreadID; 
    HANDLE hThread; 
	
    hThread = CreateThread( NULL, 0, ThreadFunc, 
		this, 0, &dwThreadID);
	
	if (hThread == NULL) 
	{
		AfxMessageBox( "  " );
	}
	else 
	{
		CloseHandle( hThread );
	}	
}

void __cdecl _thread( void* a )
{
	// :
}

void CTestThreadDlg::OnBeginThread() 
{
	// TODO: Add your control notification handler code here
	_beginthread(  _thread, 0, 0 );
}

void CTestThreadDlg::OnWaitTerm() 
{
	// TODO: Add your control notification handler code here
    DWORD dwThreadID; 
    HANDLE hThread; 
	
    hThread = CreateThread( NULL, 0, ThreadFunc, 
		this, 0, &dwThreadID);
	
	if (hThread == NULL) 
	{
		AfxMessageBox( "  " );
	}
	else 
	{
		::WaitForSingleObject( hThread, INFINITE );
		CloseHandle( hThread );
	}
}

UINT _MyControllingFunction( LPVOID pParam )
{
	Sleep(10000);
	return 0;
}

void CTestThreadDlg::OnAfxbeginthreadFunction() 
{
	// TODO: Add your control notification handler code here
	m_pThread = AfxBeginThread( _MyControllingFunction, this );
	m_pThread->m_pMainWnd = this;
	
//	Sleep(10000);
}

void CTestThreadDlg::OnCreateMywinthread() 
{
	// TODO: Add your control notification handler code here
	m_pThread = AfxBeginThread( RUNTIME_CLASS(CMyWinThread) );
}

void CTestThreadDlg::OnTmBlockingCall() 
{
	// TODO: Add your control notification handler code here
	m_pThread->PostThreadMessage( TM_BLOCKING_CALL, 0, 0 );
}

void CTestThreadDlg::OnBlockingCall() 
{
	// TODO: Add your control notification handler code here
	Sleep(3000);
}

//////////////////////////////////////////////////////////////////////
// WorkerThread's Thread Message Queue
DWORD WINAPI WorkerThread( LPVOID lpParam ) 
{ 
	MSG msg;
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		switch( msg.message )
		{
		case TM_BLOCKING_CALL :
			::MessageBox( NULL, "Bloking...", "۾ڽ", MB_OK );
			break;
		}

		// GUI   ޽ 
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}	
	
    return 0; 
} 

HANDLE g_hThread;
DWORD g_dwThreadID;
void CTestThreadDlg::OnCreateWorker() 
{
	// TODO: Add your control notification handler code here
    g_hThread = CreateThread( NULL, 0, WorkerThread, 
		this, 0, &g_dwThreadID);
	
	if (g_hThread == NULL) 
	{
		AfxMessageBox( "  " );
	}
}

void CTestThreadDlg::OnPostWorker() 
{
	// TODO: Add your control notification handler code here
	::PostThreadMessage( g_dwThreadID, TM_BLOCKING_CALL, 0, 0 );
}


////////////////////////////////////////////////////////////////////////////////
// Win32 Window in Thread
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HDC			hdc;
	PAINTSTRUCT	ps;
	RECT		rect;

	switch(msg)
	{
	case WM_PAINT:
				hdc = BeginPaint(hwnd,&ps);
				GetClientRect(hwnd,&rect);
				DrawText(hdc," Դϴ.",-1,&rect,DT_SINGLELINE|DT_CENTER+DT_VCENTER);
				EndPaint(hwnd,&ps);
				return 0;
	case WM_DESTROY:
				PostQuitMessage(0);
				return 0;
	}

	return DefWindowProc(hwnd,msg,wParam,lParam);
}


HWND Win32_CreateWindow()
{
	static char szAppName[] = "Win32 Window in Thread";
	HWND		hwnd;
	WNDCLASS	wc;
	
	wc.style		= CS_HREDRAW + CS_VREDRAW;
	wc.lpfnWndProc	= WndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= NULL;
	wc.hIcon		= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName	= NULL;
	wc.lpszClassName= szAppName;
	
	RegisterClass(&wc);

	hwnd = CreateWindow(szAppName,
						"Win32 ",
						WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						NULL,
						NULL,
						NULL,
						NULL);

	ShowWindow(hwnd, SW_SHOW);
	UpdateWindow(hwnd);

	return hwnd;
}


DWORD WINAPI Win32_In_Thread( LPVOID lpParam ) 
{ 
	Win32_CreateWindow();

	MSG msg;
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}	
    return 0; 
} 

void CTestThreadDlg::OnWin32Thread() 
{
	// TODO: Add your control notification handler code here
    DWORD dwThreadID; 
    HANDLE hThread; 
	
    hThread = CreateThread( NULL, 0, Win32_In_Thread, NULL, 0, &dwThreadID);
}



class CMFCWnd : public CFrameWnd
{
protected:	
	afx_msg void OnPaint();
	DECLARE_MESSAGE_MAP()
};

BEGIN_MESSAGE_MAP(CMFCWnd , CFrameWnd)
	ON_WM_PAINT()	
END_MESSAGE_MAP()

void CMFCWnd::OnPaint()
{
	CPaintDC dc(this);
	
	CRect rect;
	GetClientRect(&rect);
	dc.DrawText(" Դϴ.",-1,&rect,
		DT_SINGLELINE|DT_CENTER+DT_VCENTER);
}

DWORD WINAPI MFC_In_Thread( LPVOID lpParam ) 
{
	CMFCWnd* wnd = new CMFCWnd;
	wnd->Create( NULL, "asdf");
	wnd->ShowWindow( SW_SHOW);

	MSG msg;
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}	
    return 0; 
} 

void CTestThreadDlg::OnMfcThread() 
{
	// TODO: Add your control notification handler code here
    DWORD dwThreadID; 
    HANDLE hThread; 
	
    hThread = CreateThread( NULL, 0, MFC_In_Thread, NULL, 0, &dwThreadID);
}


HANDLE g_hEvent;

DWORD WINAPI _EventTest( LPVOID lpObj )
{
	HANDLE hEvent = (HANDLE)lpObj;
	DWORD dwRet;
	while( 1 )
	{
		// g_hEvent ñ׳ ° ɶ  
		dwRet = ::WaitForSingleObject( g_hEvent, INFINITE );
		// SetEvent  ñ׳εǸ Wait  
		// Auto Reseet ̹Ƿ ٷ ͽñ׳ ° 
		::MessageBox( NULL, "ñ׳εǾ", "Event", MB_OK );
	}

	return 0;
}

void CTestThreadDlg::OnEvent() 
{
	// TODO: Add your control notification handler code here
	g_hEvent = CreateEvent( NULL, FALSE, FALSE, NULL );

	DWORD dwTid;
	HANDLE hThread;
	hThread = CreateThread( NULL, 0, _EventTest, (LPVOID)g_hEvent, 0, &dwTid );
}

void CTestThreadDlg::OnSetevent() 
{
	// TODO: Add your control notification handler code here
	SetEvent( g_hEvent );
}


HANDLE g_hEvent1, g_hEvent2;

DWORD WINAPI _EventsTest( LPVOID lpObj )
{
	HANDLE hEvents[2];
	hEvents[0] = g_hEvent1;
	hEvents[1] = g_hEvent2;

	DWORD dwRet;
	while( 1 )
	{
		// hEvnets 迭 ü ϳ̶ ñ׳εǸ
		// Wait Լ  ڵ尡  
		dwRet = ::WaitForMultipleObjects( 2, hEvents, FALSE, INFINITE );
		// Auto Reseet ̹Ƿ ٷ ͽñ׳ ° 

		switch( dwRet )
		{
		case WAIT_OBJECT_0 + 0 : 
			::MessageBox( NULL, "ù° ü ñ׳εǾ", "Event", MB_OK );
			break;
		case WAIT_OBJECT_0 + 1 : 
			::MessageBox( NULL, "ι° ü ñ׳εǾ", "Event", MB_OK );
			break;
		case WAIT_TIMEOUT :
			::MessageBox( NULL, "ŸӾƿϾ", "timeout", MB_OK );
			break;
		}
	}

	return 0;
}


void CTestThreadDlg::OnEvents() 
{
	// TODO: Add your control notification handler code here
	g_hEvent1 = CreateEvent( NULL, FALSE, FALSE, NULL );
	g_hEvent2 = CreateEvent( NULL, FALSE, FALSE, NULL );

	DWORD dwTid;
	HANDLE hThread;
	hThread = CreateThread( NULL, 0, _EventsTest, NULL, 0, &dwTid );
}

void CTestThreadDlg::OnSetevent1() 
{
	// TODO: Add your control notification handler code here
	SetEvent( g_hEvent1 );
}

void CTestThreadDlg::OnSetevent2() 
{
	// TODO: Add your control notification handler code here
	SetEvent( g_hEvent2 );
}

///////////////////////////////////////////////////////////////////
// Ӱ  ڵ

#include <afxmt.h> 

CCriticalSection cs;
DWORD WINAPI ThreadFuncCS1( LPVOID lpParam ) 
{ 
	cs.Lock();
	::MessageBox( NULL, "ThreadFuncCS1", "Thread", MB_OK );

	cs.Unlock();
    return 0; 
} 
DWORD WINAPI ThreadFuncCS2( LPVOID lpParam ) 
{ 
	cs.Lock();
	::MessageBox( NULL, "ThreadFuncCS2", "Thread", MB_OK );
	cs.Unlock();
    return 0; 
} 


void CTestThreadDlg::OnCriticalSection() 
{
	// TODO: Add your control notification handler code here
   DWORD dwThreadID,dwThreadID2; 
	
    CreateThread( NULL, 0, ThreadFuncCS1, NULL, 0, &dwThreadID);
	CreateThread( NULL, 0, ThreadFuncCS2, NULL, 0, &dwThreadID2);
}
