// TcpAsyncServer.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

// 
HINSTANCE	g_hInst;
HWND		g_hWnd;
SOCKET		g_hListen;
SOCKET		g_hClient;

// WSAAsyncSelect  Ʈũ ̺Ʈ ߻ Post ޽
#define WM_MYLISTEN_NOTIFY		(WM_APP+0)
#define WM_MYSOCKET_NOTIFY		(WM_APP+1)

// ڽ Ʈ ̵
#define IDC_LISTEN				0
#define IDC_SEND				1
#define IDC_CLOSE				2

//   Ʈ ޾ ͳ ּ ü ϴ Լ
BOOL GetSockAddr( LPCTSTR lpszAddress, UINT nPort, SOCKADDR_IN* lpSa )
{
	memset(lpSa,0,sizeof(SOCKADDR_IN));

	//   sockAddr ä.
	LPSTR lpszAscii = (LPTSTR)lpszAddress;
	lpSa->sin_family = AF_INET;

	// ־ ּҰ ٸ  ּҷ(Net)   Ѵ.
	if (lpszAscii == NULL)
		lpSa->sin_addr.s_addr = htonl(INADDR_ANY);
	else
		lpSa->sin_addr.s_addr = inet_addr(lpszAscii);

	//  ּҸ  ߴٸ
	if (lpSa->sin_addr.s_addr == INADDR_NONE)
	{
		// ipּҰ ƴ϶ dns̴.
		LPHOSTENT lphost;
		lphost = gethostbyname(lpszAscii);
		if (lphost != NULL)
			lpSa->sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		else
		{
			//      ߻
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}

	// Ʈ Ѵ.
	lpSa->sin_port = htons((u_short)nPort);
	return TRUE;
}

void OnBtListen()
{
	SOCKADDR_IN bind_addr;				// ε ּ ü
	
	// TCP  Ѵ.
	g_hListen = socket( AF_INET, SOCK_STREAM, 0 );
	if( g_hListen == INVALID_SOCKET )
	{
		MessageBox( g_hWnd, "   ", "˸", MB_OK );
		return;
	}

	// ϰ ϴ ּҿ  ּ ü ´.
	if( !GetSockAddr("localhost", 6565, &bind_addr ) )
	{
		MessageBox( g_hWnd, "ּ  ", "˸", MB_OK );
		return;
	}
	
	//   ش ּҿ Ʈ εѴ.
	if (bind( g_hListen, (PSOCKADDR)&bind_addr, sizeof(bind_addr)) == SOCKET_ERROR)
	{
		MessageBox( g_hWnd, "bind ", "˸", MB_OK );
		closesocket( g_hListen );
		return;
	}

	// Ѵ.
	if( listen( g_hListen, 5 ) == SOCKET_ERROR )
	{
		MessageBox( g_hWnd, " ", "˸", MB_OK );
		closesocket( g_hListen );		
		return;
	}

	// ޽  non-blocking   Ѵ.
	WSAAsyncSelect( g_hListen, g_hWnd, WM_MYLISTEN_NOTIFY, FD_ACCEPT );
}

void OnBtSend()
{
	send( g_hClient, "world", 6, 0 );
}

void OnBtClose()
{
	shutdown( g_hClient, 1 );
}

void OnReceive()
{
	char buf[100];
	ZeroMemory( buf, 100 );

	if( recv( g_hClient, buf, 100, 0 ) == SOCKET_ERROR )
	{
		if( WSAGetLastError() == WSAEWOULDBLOCK )
			return;

		closesocket( g_hClient );
		MessageBox( g_hWnd, " ", "˸", MB_OK );
		return;
	}

	MessageBox( g_hWnd, buf, "", MB_OK );
}

// Ʈũ ̺Ʈ ߻ ȣǴ Լ
void OnMyListenNotify( WPARAM wParam, LPARAM lParam )
{
	SOCKADDR_IN saRemote;
    int nEvent = WSAGETSELECTEVENT( lParam );
    int nError = WSAGETSELECTERROR( lParam );

	if( nEvent == FD_ACCEPT && nError == 0 )
	{
		int nSockLen = sizeof(saRemote);
		// ο Ŭ̾Ʈ ޾Ƶ帰.
		g_hClient = accept( g_hListen, (PSOCKADDR)&saRemote, &nSockLen );

		// Ŭ̾Ʈ  Ʈũ ̺Ʈ Ѵ.
		WSAAsyncSelect( g_hClient, g_hWnd, WM_MYSOCKET_NOTIFY, FD_WRITE|FD_READ|FD_CLOSE );

		MessageBox( g_hWnd, "Ʈ", "˸", MB_OK );
	}
}


void OnMySocketNotify( WPARAM wParam, LPARAM lParam )
{
    int nEvent = WSAGETSELECTEVENT( lParam );
    int nError = WSAGETSELECTERROR( lParam );

	switch( nEvent )
	{
	case FD_WRITE:
		// ۸ Ⱑ Ǿ  ̴.
		break;
	case FD_READ:
		OnReceive();
		break;
	case FD_CLOSE:
		closesocket( g_hClient );
		MessageBox( g_hWnd, " !", "˸", MB_OK );
		break;
	}
}

//  ν
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE: //   ư Ʈ 
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 10, 80, 20, hwnd, (HMENU)IDC_LISTEN, g_hInst, NULL );
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 40, 80, 20, hwnd, (HMENU)IDC_SEND, g_hInst, NULL );
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 70, 80, 20, hwnd, (HMENU)IDC_CLOSE, g_hInst, NULL );
		break;

	case WM_COMMAND:
		{
		//  ư  ̺Ʈ ڵ鸵 Ѵ.
		WORD code = HIWORD(wParam);
		WORD control_id = LOWORD(wParam);
		if( code == BN_CLICKED )
		{
			switch( control_id )
			{
			case IDC_LISTEN :
				OnBtListen();
				break;
			case IDC_SEND :
				OnBtSend();
				break;
			case IDC_CLOSE :
				OnBtClose();
				break;
			}
		}
		}
		break;
	
	case WM_MYLISTEN_NOTIFY:
		OnMyListenNotify( wParam, lParam );
		break;

	case WM_MYSOCKET_NOTIFY:
		// Ʈũ ̺Ʈ ߻Ͽ.
		OnMySocketNotify( wParam, lParam );
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hwnd,msg,wParam,lParam);
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG			msg;
	WNDCLASS	wc;

	g_hInst = hInstance;

	wc.style		= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc	= WndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= hInstance;
	wc.hIcon		= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName	= NULL;
	wc.lpszClassName= "WSAAsyncSelect Server";
	
	RegisterClass(&wc);
	
	g_hWnd = CreateWindow("WSAAsyncSelect Server",
						"WSAAsyncSelect Server",
						WS_OVERLAPPEDWINDOW|WS_BORDER,
						100,
						50,
						300,
						200,
						NULL,
						NULL,
						hInstance,
						NULL);

	ShowWindow(g_hWnd, nCmdShow);
	UpdateWindow(g_hWnd);


    //  ʱȭ ؾ߸   ִ.
	WSADATA   wsaData;
    if( WSAStartup( MAKEWORD(2,2), &wsaData) != 0)
    {
        MessageBox( g_hWnd, " ʱȭ !", "˸", MB_OK );
		return 0;
    }

	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	//    cleanup Լ ȣ ؾ Ѵ.
    closesocket(g_hListen);
	closesocket(g_hClient);
    WSACleanup();

	return 0;
}



