// OverlapCompletion2.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <windows.h>
#include <winsock2.h>
#include <process.h>

#pragma comment( lib, "ws2_32.lib" )

// 
HINSTANCE	g_hInst;
HWND		g_hWnd;
SOCKET		g_hSocket;

// WSAAsyncSelect  Ʈũ ̺Ʈ ߻ Post ޽
#define WM_MYSOCKET_NOTIFY		(WM_APP+0)

// ڽ Ʈ ̵
#define IDC_CONNECT				0
#define IDC_SEND				1
#define IDC_CLOSE				2
#define IDC_RECV				3

//   Ʈ ޾ ͳ ּ ü ϴ Լ
BOOL GetSockAddr( LPCTSTR lpszAddress, UINT nPort, SOCKADDR_IN* lpSa )
{
	memset(lpSa,0,sizeof(SOCKADDR_IN));

	//   sockAddr ä.
	LPSTR lpszAscii = (LPTSTR)lpszAddress;
	lpSa->sin_family = AF_INET;

	// ־ ּҰ ٸ  ּҷ(Net)   Ѵ.
	if (lpszAscii == NULL)
		lpSa->sin_addr.s_addr = htonl(INADDR_ANY);
	else
		lpSa->sin_addr.s_addr = inet_addr(lpszAscii);

	//  ּҸ  ߴٸ
	if (lpSa->sin_addr.s_addr == INADDR_NONE)
	{
		// ipּҰ ƴ϶ dns̴.
		LPHOSTENT lphost;
		lphost = gethostbyname(lpszAscii);
		if (lphost != NULL)
			lpSa->sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		else
		{
			//      ߻
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}

	// Ʈ Ѵ.
	lpSa->sin_port = htons((u_short)nPort);
	return TRUE;
}


void OnBtConnect()
{
	SOCKADDR_IN des_addr;				//  ּ ü
	
	// TCP  Ѵ.
	//g_hSocket = socket( AF_INET, SOCK_STREAM, 0 );
	g_hSocket = WSASocket( AF_INET, SOCK_STREAM, 0, NULL, 0, WSA_FLAG_OVERLAPPED );
	if( g_hSocket == INVALID_SOCKET )
	{
		MessageBox( g_hWnd, "  ", "˸", MB_OK );
		return;
	}

	// ϰ ϴ ּҿ  ּ ü ´.
	if( !GetSockAddr("localhost", 6565, &des_addr ) )
	//if( !GetSockAddr("210.118.56.56", 6565, &des_addr ) )
	{
		MessageBox( g_hWnd, "ּ  ", "˸", MB_OK );
		return;
	}
	
	// ޽  non-blocking   Ѵ.
	// g_hSocket Ʈũ ̺Ʈ (FD_CONNECT|FD_READ|FD_WRITE|FD_CLOSE)
	// ߻ g_hWnd  WM_MYSOCKET_NOTIFY ޽ Postϰ ȴ.
	WSAAsyncSelect( g_hSocket, g_hWnd, WM_MYSOCKET_NOTIFY, 
		FD_CONNECT|FD_READ|FD_WRITE|FD_CLOSE );

	//  Ѵ.
	if( connect( g_hSocket, (PSOCKADDR)&des_addr, sizeof(des_addr)) == SOCKET_ERROR ) 
	{
		int err = WSAGetLastError();
		if( err != WSAEWOULDBLOCK )
		{
			MessageBox( g_hWnd, " ", "˸", MB_OK );
			closesocket(g_hSocket);
		}
		
		if( err == WSAEPROTONOSUPPORT )
		{
			MessageBox( g_hWnd, " ", "˸", MB_OK );
		}
	}
}

typedef struct _MYOVERLAPPED : public WSAOVERLAPPED
{
	SOCKET hSocket;
	WSABUF wsabuf;
}MYOVERLAPPED;

HANDLE g_hThread;	// I/O ó 
HANDLE g_hSend;		//  ̺Ʈ
HANDLE g_hRecv;		// ޱ ̺Ʈ
HANDLE g_hQuit;		//  ̺Ʈ
MYOVERLAPPED g_OvSend;	//   ü
MYOVERLAPPED g_OvRecv;	// ޱ  ü

void CALLBACK SendCompletionROUTINE(
  IN DWORD dwError,
  IN DWORD cbTransferred,
  IN LPWSAOVERLAPPED lpOverlapped,
  IN DWORD dwFlags
)
{
	MYOVERLAPPED* myov = (MYOVERLAPPED*)lpOverlapped;

	MessageBox( g_hWnd, "  ", "˸", MB_OK );
}

void CALLBACK RecvCompletionROUTINE(
  IN DWORD dwError,
  IN DWORD cbTransferred,
  IN LPWSAOVERLAPPED lpOverlapped,
  IN DWORD dwFlags
)
{
	MYOVERLAPPED* myov = (MYOVERLAPPED*)lpOverlapped;

	MessageBox( g_hWnd, myov->wsabuf.buf, " ޱ ", MB_OK );
}

void _CompletionThread( void* p )
{
	int nError;
	BOOL bContinue = TRUE;
	DWORD dwRet;
	HANDLE hEvents[3];
	DWORD dwSent, dwRead, dwFlags = 0;

	g_hSend = CreateEvent( NULL, FALSE, FALSE, NULL );
	g_hRecv = CreateEvent( NULL, FALSE, FALSE, NULL );
	g_hQuit = CreateEvent( NULL, FALSE, FALSE, NULL );
	
	g_OvSend.hSocket = g_hSocket;
	g_OvSend.wsabuf.buf = new char[100];
	g_OvSend.wsabuf.len = 0;

	g_OvRecv.hSocket = g_hSocket;
	g_OvRecv.wsabuf.buf = new char[100];
	g_OvRecv.wsabuf.len = 0;

	hEvents[0] = g_hSend;
	hEvents[1] = g_hRecv;
	hEvents[2] = g_hQuit;

	while( bContinue )
	{
		dwRet = WaitForMultipleObjectsEx( 3, hEvents, FALSE, INFINITE, TRUE );
		switch( dwRet )
		{
		case WAIT_OBJECT_0 + 0 :
			//  ̺Ʈ ߻
			nError = WSASend( g_OvSend.hSocket, &g_OvSend.wsabuf, 1, &dwSent,
				0, &g_OvSend, SendCompletionROUTINE );
			if( nError == 0 )
			{
				// ѹ Ⱑ Ǿ.
			}
			else
			if( nError == SOCKET_ERROR && WSAGetLastError() == WSA_IO_PENDING )
			{
				//   ۵Ǿ  ϷǸ Ϸ Լ ȣ ̴.
				//  I/O Լ ȣ      ־
				// Ϸ Լ ȣ   ִ.
				// WaitForMultipleObjectsEx()  ؼ alertable wait state ȴ.
			}
			else
			{
				//  ߻
				bContinue = FALSE;
			}
			break;

		case WAIT_OBJECT_0 + 1 :
			// ޱ ̺Ʈ ߻
			dwFlags = 0;
			nError = WSARecv( g_OvRecv.hSocket, &g_OvRecv.wsabuf, 1, &dwRead,
				&dwFlags, &g_OvRecv, RecvCompletionROUTINE );
			if( nError == 0 )
			{
				// ѹ Ⱑ Ǿ.
			}
			else
			if( nError == SOCKET_ERROR && WSAGetLastError() == WSA_IO_PENDING )
			{
				//   ۵Ǿ  ϷǸ Ϸ Լ ȣ ̴.
				//  I/O Լ ȣ      ־
				// Ϸ Լ ȣ   ִ.
				//  WaitForMultipleObjectsEx()  ؼ alertable wait state ȴ.
			}
			else
			{
				//  ߻
				bContinue = FALSE;
			}
			break;

		case WAIT_OBJECT_0 + 2 :
			//  ̺Ʈ ߻
			bContinue = FALSE;
			break;

		case WAIT_IO_COMPLETION :
			// Ϸ ƾ ȣǾ.
			break;
		}
	}

	delete [] g_OvSend.wsabuf.buf;
	delete [] g_OvRecv.wsabuf.buf;
	CloseHandle( g_hSend );
	CloseHandle( g_hRecv );
	CloseHandle( g_hQuit );
	
	closesocket( g_hSocket );
}

void OnBtSend()
{
	//    غ
	ZeroMemory( g_OvSend.wsabuf.buf, 100 );
	strcpy( g_OvSend.wsabuf.buf, "hello" );
	g_OvSend.wsabuf.len = 6;

	//  ̺Ʈ ߻
	SetEvent( g_hSend );
}

void OnBtClose()
{
	shutdown( g_hSocket, 1 );
}

void OnBtRecv()
{
	//    غ
	ZeroMemory( g_OvRecv.wsabuf.buf, 100 );
	g_OvRecv.wsabuf.len = 100;

	// ޱ ̺Ʈ ߻
	SetEvent( g_hRecv );
}

void OnReceive()
{
	OnBtRecv();
}

// Ʈũ ̺Ʈ ߻ ȣǴ Լ
void OnMySocketNotify( WPARAM wParam, LPARAM lParam )
{
    int nEvent = WSAGETSELECTEVENT( lParam );
    int nError = WSAGETSELECTERROR( lParam );

	switch( nEvent )
	{
	case FD_CONNECT:
		if( nError == 0 )
			MessageBox( g_hWnd, " !", "˸", MB_OK );
		else
		{
			//SetEvent( g_hQuit );
			closesocket( g_hSocket );
			MessageBox( g_hWnd, " !", "˸", MB_OK );
		}
		g_hThread = (HANDLE)_beginthread( _CompletionThread, 0, NULL );
		break;
	case FD_WRITE:
		// ۸ Ⱑ Ǿ  ̴.
		break;
	case FD_READ:
		OnReceive();
		break;
	case FD_CLOSE:
		SetEvent( g_hQuit );
		//closesocket( g_hSocket );
		MessageBox( g_hWnd, " !", "˸", MB_OK );
		break;
	}
}

//  ν
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE: //   ư Ʈ 
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 10, 80, 20, hwnd, (HMENU)IDC_CONNECT, g_hInst, NULL );
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 40, 80, 20, hwnd, (HMENU)IDC_SEND, g_hInst, NULL );
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 70, 80, 20, hwnd, (HMENU)IDC_CLOSE, g_hInst, NULL );
		CreateWindow( "BUTTON", "ޱ ȣ", WS_CHILD|WS_VISIBLE,
						10, 100, 80, 20, hwnd, (HMENU)IDC_RECV, g_hInst, NULL );
		break;

	case WM_COMMAND:
		{
		//  ư  ̺Ʈ ڵ鸵 Ѵ.
		WORD code = HIWORD(wParam);
		WORD control_id = LOWORD(wParam);
		if( code == BN_CLICKED )
		{
			switch( control_id )
			{
			case IDC_CONNECT :
				OnBtConnect();
				break;
			case IDC_SEND :
				OnBtSend();
				break;
			case IDC_RECV :
				OnBtRecv();
				break;
			case IDC_CLOSE :
				OnBtClose();
				break;
			}
		}
		}
		break;

	case WM_MYSOCKET_NOTIFY:
		// Ʈũ ̺Ʈ ߻Ͽ.
		OnMySocketNotify( wParam, lParam );
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hwnd,msg,wParam,lParam);
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG			msg;
	WNDCLASS	wc;

	g_hInst = hInstance;

	wc.style		= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc	= WndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= hInstance;
	wc.hIcon		= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName	= NULL;
	wc.lpszClassName= "Overlapped Completion Client2";
	
	RegisterClass(&wc);
	
	g_hWnd = CreateWindow("Overlapped Completion Client2",
						"Overlapped Completion Client2",
						WS_OVERLAPPEDWINDOW|WS_BORDER,
						100,
						50,
						300,
						200,
						NULL,
						NULL,
						hInstance,
						NULL);

	ShowWindow(g_hWnd, nCmdShow);
	UpdateWindow(g_hWnd);


    //  ʱȭ ؾ߸   ִ.
	WSADATA   wsaData;
    if( WSAStartup( MAKEWORD(2,2), &wsaData) != 0)
    {
        MessageBox( g_hWnd, " ʱȭ !", "˸", MB_OK );
		return 0;
    }

	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	//    cleanup Լ ȣ ؾ Ѵ.
    closesocket(g_hSocket);
    WSACleanup();

	return 0;
}