// OverlapEvent2.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <windows.h>
#include <winsock2.h>
#include <process.h>

#pragma comment( lib, "ws2_32.lib" )

// 
HINSTANCE	g_hInst;
HWND		g_hWnd;
SOCKET		g_hSocket;

// WSAAsyncSelect  Ʈũ ̺Ʈ ߻ Post ޽
#define WM_MYSOCKET_NOTIFY		(WM_APP+0)

// ڽ Ʈ ̵
#define IDC_CONNECT				0
#define IDC_SEND				1
#define IDC_CLOSE				2
#define IDC_RECV				3

//   Ʈ ޾ ͳ ּ ü ϴ Լ
BOOL GetSockAddr( LPCTSTR lpszAddress, UINT nPort, SOCKADDR_IN* lpSa )
{
	memset(lpSa,0,sizeof(SOCKADDR_IN));

	//   sockAddr ä.
	LPSTR lpszAscii = (LPTSTR)lpszAddress;
	lpSa->sin_family = AF_INET;

	// ־ ּҰ ٸ  ּҷ(Net)   Ѵ.
	if (lpszAscii == NULL)
		lpSa->sin_addr.s_addr = htonl(INADDR_ANY);
	else
		lpSa->sin_addr.s_addr = inet_addr(lpszAscii);

	//  ּҸ  ߴٸ
	if (lpSa->sin_addr.s_addr == INADDR_NONE)
	{
		// ipּҰ ƴ϶ dns̴.
		LPHOSTENT lphost;
		lphost = gethostbyname(lpszAscii);
		if (lphost != NULL)
			lpSa->sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		else
		{
			//      ߻
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}

	// Ʈ Ѵ.
	lpSa->sin_port = htons((u_short)nPort);
	return TRUE;
}


void OnBtConnect()
{
	SOCKADDR_IN des_addr;				//  ּ ü
	
	// TCP  Ѵ.
	//g_hSocket = socket( AF_INET, SOCK_STREAM, 0 );
	g_hSocket = WSASocket( AF_INET, SOCK_STREAM, 0, NULL, 0, WSA_FLAG_OVERLAPPED );
	if( g_hSocket == INVALID_SOCKET )
	{
		MessageBox( g_hWnd, "  ", "˸", MB_OK );
		return;
	}

	// ϰ ϴ ּҿ  ּ ü ´.
	if( !GetSockAddr("localhost", 6565, &des_addr ) )
	//if( !GetSockAddr("woos.wowdns.com", 3317, &des_addr ) )
	{
		MessageBox( g_hWnd, "ּ  ", "˸", MB_OK );
		return;
	}
	
	// ޽  non-blocking   Ѵ.
	// g_hSocket Ʈũ ̺Ʈ (FD_CONNECT|FD_READ|FD_WRITE|FD_CLOSE)
	// ߻ g_hWnd  WM_MYSOCKET_NOTIFY ޽ Postϰ ȴ.
	WSAAsyncSelect( g_hSocket, g_hWnd, WM_MYSOCKET_NOTIFY, 
		FD_CONNECT|FD_READ|FD_WRITE|FD_CLOSE );

	//  Ѵ.
	if( connect( g_hSocket, (PSOCKADDR)&des_addr, sizeof(des_addr)) == SOCKET_ERROR ) 
	{
		int err = WSAGetLastError();
		if( err != WSAEWOULDBLOCK )
		{
			MessageBox( g_hWnd, " ", "˸", MB_OK );
			closesocket(g_hSocket);
		}
		
		if( err == WSAEPROTONOSUPPORT )
		{
			MessageBox( g_hWnd, " ", "˸", MB_OK );
		}
	}
}

typedef struct _MYOVERLAPPED
{
	WSAOVERLAPPED ov;

	SOCKET		hSocket;
	WSABUF		wsabuf;
}MYOVERLAPPED;

MYOVERLAPPED g_myov[2];  // [0] send overlap, [1] recv overlap
HANDLE		g_hOvQuit;
HANDLE		g_hThread;

void _OverlappedThread( void* p )
{
	DWORD dwRet;
	HANDLE hEvents[3];
	BOOL bContinue = TRUE;
	DWORD dwTransfer, dwFlags;

	//  ޱ  ü 
	g_myov[0].hSocket = g_hSocket;
	g_myov[0].ov.hEvent = WSACreateEvent();
	g_myov[0].wsabuf.buf = new char[100];
	g_myov[0].wsabuf.len = 0;
	
	g_myov[1].hSocket = g_hSocket;
	g_myov[1].ov.hEvent = WSACreateEvent();
	g_myov[1].wsabuf.buf = new char[100];
	g_myov[1].wsabuf.len = 0;

	//  ̺Ʈ ü 
	g_hOvQuit = CreateEvent( NULL, FALSE, FALSE, NULL );

	// WaitForMultipleObjects  ڵ 迭
	hEvents[0] = g_myov[0].ov.hEvent;
	hEvents[1] = g_myov[1].ov.hEvent;
	hEvents[2] = g_hOvQuit;

	while( bContinue )
	{
		//  ϳ ñ׳εǾ Wait ´.
		dwRet = WaitForMultipleObjects( 3, hEvents, FALSE, INFINITE );
		
		switch( dwRet )
		{
		case WAIT_OBJECT_0 + 0 : //  Ϸ 뺸
			//  Ϸ ȣȴ.
			WSAGetOverlappedResult( g_myov[0].hSocket, &g_myov[0].ov, &dwTransfer, TRUE, &dwFlags );
			WSAResetEvent( g_myov[0].ov.hEvent );
			MessageBox( g_hWnd, g_myov[0].wsabuf.buf, "  ", MB_OK );
			break;
		case WAIT_OBJECT_0 + 1 : // ޱ Ϸ 뺸
			//
			WSAGetOverlappedResult( g_myov[1].hSocket, &g_myov[1].ov, &dwTransfer, TRUE, &dwFlags );
			WSAResetEvent( g_myov[1].ov.hEvent );
			MessageBox( g_hWnd, g_myov[1].wsabuf.buf, " ޱ ", MB_OK );
			break;
		case WAIT_OBJECT_0 + 2 : // α׷ 
			bContinue = FALSE;
			break;
		}
	}

	// close handles
	delete [] g_myov[0].wsabuf.buf;
	delete [] g_myov[1].wsabuf.buf;
	WSACloseEvent( g_myov[0].ov.hEvent );
	WSACloseEvent( g_myov[1].ov.hEvent );
	CloseHandle( g_hOvQuit );

	closesocket( g_hSocket );
}


void OnBtSend()
{
	int nError;
	DWORD dwSent;
	
	//    غ
	ZeroMemory( g_myov[0].wsabuf.buf, 100 );
	strcpy( g_myov[0].wsabuf.buf, "hello" );
	g_myov[0].wsabuf.len = 6;

	//   õѴ.
	nError = WSASend( g_hSocket, &g_myov[0].wsabuf, 1, &dwSent, 0, (LPOVERLAPPED)&g_myov[0], NULL );

	if( nError == 0 )
	{
		// ѹ Ⱑ Ǿ.
	}
	else
	if( nError == SOCKET_ERROR && WSAGetLastError() == WSA_IO_PENDING )
	{
		//   Ⱑ ̴.
	}
	else
	{
		//  .
		closesocket( g_hSocket );
	}
}

void OnBtClose()
{
	shutdown( g_hSocket, 1 );
}

void OnBtRecv()
{
	int nError;
	DWORD dwFlags = 0;
	DWORD dwRead;
	
	//    غ
	ZeroMemory( g_myov[1].wsabuf.buf, 100 );
	g_myov[1].wsabuf.len = 100;

	//  ޱ õѴ.
	nError = WSARecv( g_hSocket, &g_myov[1].wsabuf, 1, &dwRead, &dwFlags, (LPOVERLAPPED)&g_myov[1], NULL );
	if( nError == 0 )
	{
		// ѹ ޱⰡ Ǿ.
	}
	else
	if( nError == SOCKET_ERROR && WSAGetLastError() == WSA_IO_PENDING )
	{
		//    ̴.
	}
	else
	{
		// ޱ .
		closesocket( g_hSocket );
	}
}

void OnReceive()
{
	// FD_READ ߻

	//  WSARecv() ó ȣѴ.
	OnBtRecv();
}

// Ʈũ ̺Ʈ ߻ ȣǴ Լ
void OnMySocketNotify( WPARAM wParam, LPARAM lParam )
{
    int nEvent = WSAGETSELECTEVENT( lParam );
    int nError = WSAGETSELECTERROR( lParam );

	switch( nEvent )
	{
	case FD_CONNECT:
		if( nError == 0 )
			MessageBox( g_hWnd, " !", "˸", MB_OK );
		else
		{
			SetEvent( g_hOvQuit );
			//closesocket( g_hSocket );
			MessageBox( g_hWnd, " !", "˸", MB_OK );
		}

		g_hThread = (HANDLE)_beginthread( _OverlappedThread, 0, NULL );
		break;
	case FD_WRITE:
		// ۸ Ⱑ Ǿ  ̴.
		break;
	case FD_READ:
		OnReceive();
		break;
	case FD_CLOSE:
		SetEvent( g_hOvQuit );
		//closesocket( g_hSocket );
		MessageBox( g_hWnd, " !", "˸", MB_OK );
		break;
	}
}

//  ν
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE: //   ư Ʈ 
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 10, 80, 20, hwnd, (HMENU)IDC_CONNECT, g_hInst, NULL );
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 40, 80, 20, hwnd, (HMENU)IDC_SEND, g_hInst, NULL );
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 70, 80, 20, hwnd, (HMENU)IDC_CLOSE, g_hInst, NULL );
		CreateWindow( "BUTTON", "ޱ ȣ", WS_CHILD|WS_VISIBLE,
						10, 100, 80, 20, hwnd, (HMENU)IDC_RECV, g_hInst, NULL );
		break;

	case WM_COMMAND:
		{
		//  ư  ̺Ʈ ڵ鸵 Ѵ.
		WORD code = HIWORD(wParam);
		WORD control_id = LOWORD(wParam);
		if( code == BN_CLICKED )
		{
			switch( control_id )
			{
			case IDC_CONNECT :
				OnBtConnect();
				break;
			case IDC_SEND :
				OnBtSend();
				break;
			case IDC_RECV :
				OnBtRecv();
				break;
			case IDC_CLOSE :
				OnBtClose();
				break;
			}
		}
		}
		break;

	case WM_MYSOCKET_NOTIFY:
		// Ʈũ ̺Ʈ ߻Ͽ.
		OnMySocketNotify( wParam, lParam );
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hwnd,msg,wParam,lParam);
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG			msg;
	WNDCLASS	wc;

	g_hInst = hInstance;

	wc.style		= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc	= WndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= hInstance;
	wc.hIcon		= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName	= NULL;
	wc.lpszClassName= "Overlapped Event Client2";
	
	RegisterClass(&wc);
	
	g_hWnd = CreateWindow("Overlapped Event Client2",
						"Overlapped Event Client2",
						WS_OVERLAPPEDWINDOW|WS_BORDER,
						100,
						50,
						300,
						200,
						NULL,
						NULL,
						hInstance,
						NULL);

	ShowWindow(g_hWnd, nCmdShow);
	UpdateWindow(g_hWnd);


    //  ʱȭ ؾ߸   ִ.
	WSADATA   wsaData;
    if( WSAStartup( MAKEWORD(2,2), &wsaData) != 0)
    {
        MessageBox( g_hWnd, " ʱȭ !", "˸", MB_OK );
		return 0;
    }

	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	//    cleanup Լ ȣ ؾ Ѵ.
    closesocket(g_hSocket);
    WSACleanup();

	return 0;
}
