// ChatClientDlg.h : header file
//

#if !defined(AFX_CHATCLIENTDLG_H__7F4E1B58_EC26_46A5_B615_DBB905481E1E__INCLUDED_)
#define AFX_CHATCLIENTDLG_H__7F4E1B58_EC26_46A5_B615_DBB905481E1E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ClientSocket.h"
#include "DlgChattingRoom.h"
/////////////////////////////////////////////////////////////////////////////
// CChatClientDlg dialog

#define MAXUSER_IN_ROOM 10

class CChatClientDlg : public CDialog
{
// Construction
public:
	CChatClientDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CChatClientDlg)
	enum { IDD = IDD_CHATCLIENT_DIALOG };
	CButton	m_createRoom;
	CListBox	m_userList;
	CButton	m_connect;
	CListCtrl	m_roomList;
	CString	m_ipAddr;
	CString	m_nickName;
	CString	m_portNum;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChatClientDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CChatClientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnConnect();
	afx_msg void OnReceive(UINT,LONG);
	afx_msg void OnCreateRoom();
	afx_msg void OnDblclkRoomList(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void InitRoomList();
	void insertChatRoom(char* roomNum,char* roomName,char* userCount);
	void resetLobbyData();
	void joinRoom(int roomNum,CString userName);

	CClientSocket *m_pClientSock;
	CDlgChattingRoom *pChatDlg;
	DWORD listCount;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHATCLIENTDLG_H__7F4E1B58_EC26_46A5_B615_DBB905481E1E__INCLUDED_)
