// TcpAsyncClientMfcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TcpAsyncClientMfc.h"
#include "TcpAsyncClientMfcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTcpAsyncClientMfcDlg dialog

CTcpAsyncClientMfcDlg::CTcpAsyncClientMfcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTcpAsyncClientMfcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTcpAsyncClientMfcDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTcpAsyncClientMfcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTcpAsyncClientMfcDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTcpAsyncClientMfcDlg, CDialog)
	//{{AFX_MSG_MAP(CTcpAsyncClientMfcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MYSOCKET_NOTIFY, OnMySocketNotify)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTcpAsyncClientMfcDlg message handlers

BOOL CTcpAsyncClientMfcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTcpAsyncClientMfcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTcpAsyncClientMfcDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTcpAsyncClientMfcDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL GetSockAddr( LPCTSTR lpszAddress, UINT nPort, SOCKADDR_IN* lpSa )
{
	memset(lpSa,0,sizeof(SOCKADDR_IN));

	//   sockAddr ä.
	LPSTR lpszAscii = (LPTSTR)lpszAddress;
	lpSa->sin_family = AF_INET;

	// ־ ּҰ ٸ  ּҷ(Net)   Ѵ.
	if (lpszAscii == NULL)
		lpSa->sin_addr.s_addr = htonl(INADDR_ANY);
	else
		lpSa->sin_addr.s_addr = inet_addr(lpszAscii);

	//  ּҸ  ߴٸ
	if (lpSa->sin_addr.s_addr == INADDR_NONE)
	{
		// ipּҰ ƴ϶ dns̴.
		LPHOSTENT lphost;
		lphost = gethostbyname(lpszAscii);
		if (lphost != NULL)
			lpSa->sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		else
		{
			//      ߻
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}

	// Ʈ Ѵ.
	lpSa->sin_port = htons((u_short)nPort);
	return TRUE;
}


void CTcpAsyncClientMfcDlg::OnConnect() 
{
	// TODO: Add your control notification handler code here
	SOCKADDR_IN des_addr;        // Server socket address
	PHOSTENT phostent = NULL;           // Points to the HOSTENT structure
	

	m_hSocket = socket( AF_INET, SOCK_STREAM, 0 );
	if( m_hSocket == INVALID_SOCKET )
	{
		AfxMessageBox( "  " );
		return;
	}

	if( !GetSockAddr("localhost", 6565, &des_addr ) )
	{
		AfxMessageBox( "ּ  " );
		return;
	}
	
	WSAAsyncSelect( m_hSocket, GetSafeHwnd(), WM_MYSOCKET_NOTIFY, FD_CONNECT|FD_WRITE|FD_READ|FD_CLOSE );

	//  Ѵ.
	if ( connect( m_hSocket, (PSOCKADDR)&des_addr, sizeof (des_addr)) == SOCKET_ERROR) 
	{
		if( WSAGetLastError() != WSAEWOULDBLOCK )
		{
			AfxMessageBox( " " );
			closesocket(m_hSocket);
		}
	}	
}

void CTcpAsyncClientMfcDlg::OnReceive()
{
	char buf[100];
	ZeroMemory( buf, 100 );

	if( recv( m_hSocket, buf, 100, 0 ) == SOCKET_ERROR )
	{
		if( WSAGetLastError() == WSAEWOULDBLOCK )
			return;

		closesocket( m_hSocket );
		AfxMessageBox( " " );
		return;
	}

	AfxMessageBox( buf );
}

LRESULT CTcpAsyncClientMfcDlg::OnMySocketNotify( WPARAM wParam, LPARAM lParam )
{
    int nEvent = WSAGETSELECTEVENT( lParam );
    int nError = WSAGETSELECTERROR( lParam );

	switch( nEvent )
	{
	case FD_CONNECT:
		if( nError == 0 )
			AfxMessageBox( " !" );
		else
		{
			closesocket( m_hSocket );
			AfxMessageBox( " !" );
		}
		break;
	case FD_WRITE:
		// ۸ Ⱑ Ǿ  ̴.
		break;
	case FD_READ:
		OnReceive();
		break;
	case FD_CLOSE:
		closesocket( m_hSocket );
		AfxMessageBox( " !" );
		break;
	}
	return 0;
}

void CTcpAsyncClientMfcDlg::OnSend() 
{
	// TODO: Add your control notification handler code here
	send( m_hSocket, "hello", 6, 0 );
}

void CTcpAsyncClientMfcDlg::OnClose() 
{
	// TODO: Add your control notification handler code here
	shutdown( m_hSocket, 1 );
}
