// IOCP.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <windows.h>
#include <winsock2.h>
#include <process.h>

#pragma comment( lib, "ws2_32.lib" )

// 
HINSTANCE	g_hInst;
HWND		g_hWnd;
SOCKET		g_hListen;

HANDLE		g_hIocp;

// IOCP  ؽƮ
typedef struct _SOCKET_CONTEXT{
	SOCKET	hSocket;
}SOCKET_CONTEXT;

// IOCP I/O ؽƮ
#define IO_TYPE_SEND				0
#define IO_TYPE_RECV				1
typedef struct _IO_CONTEXT
{
	WSAOVERLAPPED	ov;
	BOOL			type;
	char			buf[100];
	WSABUF			wsabuf;
}IO_CONTEXT;

// WSAAsyncSelect  Ʈũ ̺Ʈ ߻ Post ޽
#define WM_MYLISTEN_NOTIFY		(WM_APP+0)

// ڽ Ʈ ̵
#define IDC_LISTEN				0

//   Ʈ ޾ ͳ ּ ü ϴ Լ
BOOL GetSockAddr( LPCTSTR lpszAddress, UINT nPort, SOCKADDR_IN* lpSa )
{
	memset(lpSa,0,sizeof(SOCKADDR_IN));

	//   sockAddr ä.
	LPSTR lpszAscii = (LPTSTR)lpszAddress;
	lpSa->sin_family = AF_INET;

	// ־ ּҰ ٸ  ּҷ(Net)   Ѵ.
	if (lpszAscii == NULL)
		lpSa->sin_addr.s_addr = htonl(INADDR_ANY);
	else
		lpSa->sin_addr.s_addr = inet_addr(lpszAscii);

	//  ּҸ  ߴٸ
	if (lpSa->sin_addr.s_addr == INADDR_NONE)
	{
		// ipּҰ ƴ϶ dns̴.
		LPHOSTENT lphost;
		lphost = gethostbyname(lpszAscii);
		if (lphost != NULL)
			lpSa->sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		else
		{
			//      ߻
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}

	// Ʈ Ѵ.
	lpSa->sin_port = htons((u_short)nPort);
	return TRUE;
}

void IOCP_Recv( SOCKET_CONTEXT* pSocket )
{
	int nError;
	DWORD dwRecv, dwFlags = 0;

	IO_CONTEXT* pIO = new IO_CONTEXT;
	ZeroMemory( pIO, sizeof( IO_CONTEXT ) );
	pIO->wsabuf.buf = pIO->buf;
	pIO->wsabuf.len = 100;
	pIO->type = IO_TYPE_RECV;

	nError = WSARecv( pSocket->hSocket, &pIO->wsabuf, 1, &dwRecv, &dwFlags, &pIO->ov, NULL );
	if( nError == 0 )
	{
		// ѹ ޱ 
	}
	else
	if( nError == SOCKET_ERROR && WSAGetLastError() == WSA_IO_PENDING )
	{
		// IOCP I/O ޱ û 
	}
	else
	{
		// ,  ݱ
		closesocket( pSocket->hSocket );
		// ü ı
		delete pSocket;
		delete pIO;
	}
}

void IOCP_Send( SOCKET_CONTEXT* pSocket, char* pBuf )
{
	int nError;
	DWORD dwSend;

	IO_CONTEXT* pIO = new IO_CONTEXT;
	ZeroMemory( pIO, sizeof( IO_CONTEXT ) );
	pIO->wsabuf.buf = pIO->buf;
	strcpy( pIO->wsabuf.buf, pBuf );
	pIO->wsabuf.len = sizeof(pBuf)+1;
	pIO->type = IO_TYPE_SEND;

	nError = WSASend( pSocket->hSocket, &pIO->wsabuf, 1, &dwSend, 0, &pIO->ov, NULL );
	if( nError == 0 )
	{
		// ѹ  
	}
	else
	if( nError == SOCKET_ERROR && WSAGetLastError() == WSA_IO_PENDING )
	{
		// IOCP I/O  û 
	}
	else
	{
		// ,  ݱ
		closesocket( pSocket->hSocket );
		// ü ı
		delete pSocket;
		delete pIO;
	}
}

void _IOCPThread( void* p )
{
	SOCKET_CONTEXT* pSocket = NULL;
	IO_CONTEXT* pIO = NULL;
	BOOL bRet;
	DWORD dwTransfer;

	while( 1 )
	{
		bRet = GetQueuedCompletionStatus( g_hIocp, &dwTransfer, (LPDWORD)&pSocket, (LPOVERLAPPED*)&pIO, INFINITE );

		//   
		if( dwTransfer == 0 )
		{
			if( pIO )
			{
				closesocket( pSocket->hSocket );
				delete pSocket;				
				delete pIO;
			}
			continue;
		}

		// io NULL̸ I/O Ϸ Ŷ ƴ϶  ޽̴.
		if( pIO )
		{
			//  Ͱ ִ.
			if( pIO->type == IO_TYPE_RECV )
			{
				MessageBox( g_hWnd, pIO->buf, "", MB_OK );

				// ٽ   ְ I/O û Ѵ.
				IOCP_Recv( pSocket );

				// ޾Ƿ  ͸ ó  ˸´  ش.
				IOCP_Send( pSocket, "world" );
			}
			else
			//  Ͱ ִ.
			if( pIO->type == IO_TYPE_SEND )
			{
				// ó   óѴ.
			}

			// IO Ѵ.
			delete pIO;
		}
	}
}

void OnBtListen()
{
	SOCKADDR_IN bind_addr;				// ε ּ ü
	
	// TCP  Ѵ.
	g_hListen = WSASocket( AF_INET, SOCK_STREAM, 0, NULL, 0, WSA_FLAG_OVERLAPPED );
	if( g_hListen == INVALID_SOCKET )
	{
		MessageBox( g_hWnd, "   ", "˸", MB_OK );
		return;
	}

	// ϰ ϴ ּҿ  ּ ü ´.
	if( !GetSockAddr("localhost", 6565, &bind_addr ) )
	{
		MessageBox( g_hWnd, "ּ  ", "˸", MB_OK );
		return;
	}
	
	//   ش ּҿ Ʈ εѴ.
	if (bind( g_hListen, (PSOCKADDR)&bind_addr, sizeof(bind_addr)) == SOCKET_ERROR)
	{
		MessageBox( g_hWnd, "bind ", "˸", MB_OK );
		closesocket( g_hListen );
		return;
	}

	// Ѵ.
	if( listen( g_hListen, 5 ) == SOCKET_ERROR )
	{
		MessageBox( g_hWnd, " ", "˸", MB_OK );
		closesocket( g_hListen );		
		return;
	}

	// ޽  non-blocking   Ѵ.
	WSAAsyncSelect( g_hListen, g_hWnd, WM_MYLISTEN_NOTIFY, FD_ACCEPT );

	//////////////////////////////////////////////////////////////////////
	// IOCP Ѵ.
	g_hIocp = CreateIoCompletionPort( INVALID_HANDLE_VALUE, NULL, 0, 0 );
	if( g_hIocp == NULL )
	{
		MessageBox( g_hWnd, "IOCP  ", "˸", MB_OK );
		closesocket( g_hListen );
		return;
	}

	// IOCP ó 带 Ѵ.
	SYSTEM_INFO si;
	DWORD i;

	GetSystemInfo( &si );
	for( i = 0 ; i < si.dwNumberOfProcessors * 2; i ++ )
	{
		_beginthread( _IOCPThread, 0, 0 );
	}
}


// Ʈũ ̺Ʈ ߻ ȣǴ Լ
void OnMyListenNotify( WPARAM wParam, LPARAM lParam )
{
	SOCKADDR_IN saRemote;
    int nEvent = WSAGETSELECTEVENT( lParam );
    int nError = WSAGETSELECTERROR( lParam );

	if( nEvent == FD_ACCEPT && nError == 0 )
	{
		SOCKET hClient;
		int nSockLen = sizeof(saRemote);
		// ο Ŭ̾Ʈ ޾Ƶ帰.
		hClient = accept( g_hListen, (PSOCKADDR)&saRemote, &nSockLen );

		SOCKET_CONTEXT* pSocket = new SOCKET_CONTEXT;
		pSocket->hSocket = hClient;

		// Ʈ  IOCP Ų.
		CreateIoCompletionPort( (HANDLE)hClient, g_hIocp, (DWORD)pSocket , 0 );

		// ʷ WSARecv()  WSASend()  ϰԵȴ.
		// ڽ   Ĵ ϸȴ. 
		IOCP_Recv( pSocket );
	}
}

//  ν
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE: //   ư Ʈ 
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 10, 80, 20, hwnd, (HMENU)IDC_LISTEN, g_hInst, NULL );
		break;

	case WM_COMMAND:
		{
		//  ư  ̺Ʈ ڵ鸵 Ѵ.
		WORD code = HIWORD(wParam);
		WORD control_id = LOWORD(wParam);
		if( code == BN_CLICKED )
		{
			switch( control_id )
			{
			case IDC_LISTEN :
				OnBtListen();
				break;
			}
		}
		}
		break;
	
	case WM_MYLISTEN_NOTIFY:
		OnMyListenNotify( wParam, lParam );
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hwnd,msg,wParam,lParam);
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG			msg;
	WNDCLASS	wc;

	g_hInst = hInstance;

	wc.style		= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc	= WndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= hInstance;
	wc.hIcon		= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName	= NULL;
	wc.lpszClassName= "IOCP Server";
	
	RegisterClass(&wc);
	
	g_hWnd = CreateWindow("IOCP Server",
						"IOCP Server",
						WS_OVERLAPPEDWINDOW|WS_BORDER,
						100,
						50,
						300,
						200,
						NULL,
						NULL,
						hInstance,
						NULL);

	ShowWindow(g_hWnd, nCmdShow);
	UpdateWindow(g_hWnd);


    //  ʱȭ ؾ߸   ִ.
	WSADATA   wsaData;
    if( WSAStartup( MAKEWORD(2,2), &wsaData) != 0)
    {
        MessageBox( g_hWnd, " ʱȭ !", "˸", MB_OK );
		return 0;
    }

	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	//    cleanup Լ ȣ ؾ Ѵ.
    closesocket(g_hListen);
    WSACleanup();

	return 0;
}

